#pragma once

namespace AMDiS
{
  class DOFVectorInterface
  {
  public:
    /// Virtual destructor
    virtual ~DOFVectorInterface() = default;

    /// Change dimension of DOFVector to dimension of basis
    virtual void resize() = 0;

    /// \brief Prepare the data interpolation between grids
    /**
     * \param mightCoarsen  Indicator that any element in the grid might be
     *                      coarsened in adapt()
     **/
    virtual void preAdapt(bool mightCoarsen) = 0;

    /// \brief Apply the actual interpolation
    /**
     * \param refined  Indicator that at least one entity was refined
     **/
    virtual void postAdapt(bool refined) = 0;
  };

} // end namespace AMDiS
